﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Resources;
using ThinkGeo.MapSuite.SilverlightCore;
using ThinkGeo.MapSuite.SilverlightEdition;

namespace PointStyleDemo
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            WorldMapKitWmsSilverlightOverlay baseOverlay = new WorldMapKitWmsSilverlightOverlay();
            Map1.Overlays.Add(baseOverlay);

            LayerOverlay shapefileOverlay = new LayerOverlay();
            Map1.Overlays.Add(shapefileOverlay);

            ShapeFileFeatureLayer layer = new ShapeFileFeatureLayer("a.shp");
            ((ShapeFileFeatureSource)layer.FeatureSource).StreamLoading += new EventHandler<StreamLoadingEventArgs>(MainPage_StreamLoading);
            layer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(new GeoImage(new Uri("PURPLE.png", UriKind.RelativeOrAbsolute), 24, 24));
            layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            shapefileOverlay.Layers.Add(layer);

            Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
        }

        void MainPage_StreamLoading(object sender, StreamLoadingEventArgs e)
        {
            switch (System.IO.Path.GetExtension(e.AlternateStreamName).ToLower())
            {
                case ".shp":
                    StreamResourceInfo sr = Application.GetResourceStream(new Uri(@"Data/MajorCities.SHP", UriKind.RelativeOrAbsolute));
                    e.AlternateStream = sr.Stream;
                    break;
                case ".dbf":
                    e.AlternateStream = Application.GetResourceStream(new Uri("Data/MajorCities.dbf", UriKind.RelativeOrAbsolute)).Stream;
                    break;
                case ".shx":
                    e.AlternateStream = Application.GetResourceStream(new Uri("Data/MajorCities.shx", UriKind.RelativeOrAbsolute)).Stream;
                    break;
                case ".idx":
                    e.AlternateStream = Application.GetResourceStream(new Uri("Data/MajorCities.idx", UriKind.RelativeOrAbsolute)).Stream;
                    break;
                case ".ids":
                    e.AlternateStream = Application.GetResourceStream(new Uri("Data/MajorCities.ids", UriKind.RelativeOrAbsolute)).Stream;
                    break;
                default:
                    break;
            }
        }

    }
}
